/* eslint-disable */
<template>
<div>
    <v-container>
      <v-layout>
        <v-flex md12>
                <v-card color="blue-grey darken-2" class="white--text">
                  <v-layout>
                    <v-flex xs2>
                      <v-img
                        src="http://cdn.onlinewebfonts.com/svg/img_569505.png"
                        height="100px"
                        contain
                      ></v-img>
                    </v-flex>
                    <v-flex xs5>
                      <v-card-title primary-title>
                        <div>
                          <div class="headline">Technology: {{currentSkill.title}}</div>
                          <div>URL: {{currentSkill.url}}</div>
                          <div>Staff count: {{currentSkill.employees}}</div>
                          <div>Used in projects: {{currentSkill.projects}}</div>
                        </div>
                      </v-card-title>
                    </v-flex>
                    <v-flex xs3></v-flex>
                    <v-flex xs2>
                      <v-btn
                        flat color="white"
                        @click.stop="dialog = true"
                      >
                        <v-icon>edit</v-icon>
                      </v-btn>
                      <v-btn
                        flat color="white"
                        @click.stop="dialogDelete = true"
                      >
                        <v-icon>delete_forever</v-icon>
                      </v-btn>
                    </v-flex>
                  </v-layout>
                  <v-divider light></v-divider>
                </v-card>
              </v-flex>
      </v-layout>
      <br>
    <v-tabs
      color="blue-grey darken-2"
      dark
      slider-color="yellow">
      <v-tab>
        Info
      </v-tab>
      <v-tab>
          Skill tree
      </v-tab>
      <v-divider light></v-divider>
      <v-tab-item>
                    <v-card>
                        <v-flex>
                        <v-card color="blue-grey lighten-3">
                          <v-layout>
                            <v-flex>
                              <v-card-title primary-title>
                                <div>
                                  <div class="headline">Technology info</div>
                                    <v-card-text>
                                      <div>Version: {{currentSkill.version}}</div>
                                      <div>GIT: {{currentSkill.git}}</div>
                                    </v-card-text>
                                  </div>
                              </v-card-title>
                             </v-flex>
                           </v-layout>
                          <v-divider light></v-divider>
                        </v-card>
                        </v-flex>
                    </v-card>
        <v-divider light></v-divider>
                    <v-card>
                        <v-flex>
                        <v-card color="blue-grey lighten-3">
                          <v-layout>
                            <v-flex>
                              <v-card-title primary-title>
                                <div>
                                  <div class="headline">Description</div>
                                    <v-card-text>
                                     <div>{{currentSkill.description}}</div>
                                    </v-card-text>
                                  </div>
                              </v-card-title>
                             </v-flex>
                           </v-layout>
                        </v-card>
                        </v-flex>
                    </v-card>
        </v-tab-item>
        <v-tab-item>
            <v-card>
              <v-flex>
                <v-card color="blue-grey lighten-3">
                  <v-layout>
                    <v-flex>
                      <v-card-title primary-title>
                        <div>
                          <div class="headline">Skill tree</div>
                          <v-card-text>
                            <div>TODO: skilltree</div>
                          </v-card-text>
                        </div>
                      </v-card-title>
                    </v-flex>
                  </v-layout>
                </v-card>
              </v-flex>
            </v-card>
        </v-tab-item>
      </v-tabs>
      <v-layout justify-center>
      <v-dialog
        v-model="dialog"
        max-width="900">
        <v-card>
          <h2>Edit skill</h2>
          <v-card-text>
            <v-form>
              <v-flex>
                <v-text-field
                  v-bind:placeholder="currentSkill.title"
                  v-model="editSkill.title"
                  label="Title"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
              <v-select
                v-bind:placeholder="currentSkill.type"
                v-model="editSkill.type"
                :items="skillsTypes"
                :menu-props="{ maxHeight: '400' }"
                label="Type"
                persistent-hint>
              </v-select>
                <v-select
                  v-bind:placeholder="currentSkill.category"
                  v-model="editSkill.category"
                  :items="skillsCategories"
                  :menu-props="{ maxHeight: '400' }"
                  label="Category"
                  persistent-hint>
              </v-select>
                <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentSkill.url"
                    v-model="editSkill.url"
                    label="Website URL"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentSkill.git"
                    v-model="editSkill.git"
                    label="Git URL"
                    required>
                  </v-text-field>
                </v-flex>
                <v-select
                  v-bind:placeholder="currentSkill.connectedCategories"
                  v-model="editSkill.connectedCategories"
                  :items="skillsCategoriesConnected"
                  :menu-props="{ maxHeight: '400' }"
                  label="Connected categories"
                  multiple
                  persistent-hint>
                </v-select>
                <v-flex>
                  <v-select
                    v-bind:placeholder="currentSkill.parentSkill"
                    v-model="editSkill.parentSkill"
                    :items="skillsTypes"
                    :menu-props="{ maxHeight: '400' }"
                    label="Parent skills"
                    persistent-hint>
                  </v-select>
                </v-flex>
              <v-flex>
                  <v-select
                    v-bind:placeholder="currentSkill.childSkills"
                    v-model="editSkill.childSkills"
                    :items="skillsTypes"
                    :menu-props="{ maxHeight: '400' }"
                    label="Child skills"
                    multiple
                    persistent-hint>
                  </v-select>
                </v-flex>
                <v-text-field
                  v-bind:placeholder="currentSkill.tags"
                  v-model="editSkill.tags"
                  label="Tags"
                  required
                ></v-text-field>
                <v-text-field
                  v-bind:placeholder="currentSkill.description"
                  v-model="editSkill.description"
                  label="Description"
                  required
                >
                </v-text-field>
              </v-flex>
              </v-form>
          </v-card-text>
        <div align="center">
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="dialog = false; editErrorMsg = ''">
              Cancel
            </v-btn>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="changeSkill">
              Save
            </v-btn>
         </div>
          <div>
            <p style="color: red">{{editErrorMsg}}</p>
          </div>
        </v-card>
      </v-dialog>
    </v-layout>
      <v-layout justify-center>
      <v-dialog
        v-model="dialogDelete"
        max-width="300">
        <v-card>
          <h2>Delete skill</h2>
          <v-card-text>
            <h3>Are you sure?</h3>
          </v-card-text>
            <v-spacer></v-spacer>
          <div>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="dialogDelete = false; deleteErrorMsg = ''">
              Cancel
            </v-btn>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="deleteSkill">
              Delete
            </v-btn>
            </div>
          <div>
                  <p style="color: red">{{deleteErrorMsg}}</p>
            </div>
        </v-card>
      </v-dialog>
    </v-layout>
    </v-container>
  </div>
</template>

<script>
/* eslint-disable */

export default {
  name    : 'Skill',
  data () {
    return {
      dialog        : false,
      dialogDelete  : false,
      breweries     : [],
      isLoading     : false,
      tree          : [],
      types         : [],
      currentSkill  : {
        title              : '',
        type               : '',
        category           : '',
        url                : '',
        git                : '',
        connectedCategories: [],
        parentSkill        : {},
        childSkills        : [],
        tags               : [],
        description        : '',
        version            : '',
        employees          : '',
        projects           : ''
      },
      editSkill     : {
        id                 : this.$route.params.id,
        title              : '',
        type               : '',
        category           : '',
        url                : '',
        git                : '',
        connectedCategories: [],
        parentSkill        : {},
        childSkills        : [],
        tags               : [],
        description        : '',
        version            : '',
        employees          : '',
        projects           : ''
      },
      editErrorMsg  : '',
      deleteErrorMsg: ''
    }
  },
  mounted () {
    // alert('mounted!')
    let id = this.$route.params.id
    // alert('id=' + id)
    let found = null
    let skills = this.$store.getters.getSkills
    // alert('skills=' + skills)
    for (let i = 0; i < skills.length; i++) {
      // alert('i = ' + i + ' , skills[i].id=' + skills[i].id + ' ID=' + id)
      // alert(skills[i].id == id)
      if (skills[i].id == id) {
        // alert('found at i = ' + i)
        found = skills[i]
        break
      }
    }
    // alert('found = ' + found)
    if (found) {
      this.currentSkill = found
    }
  },
  computed: {
    items () {
      const children = this.types.map(type => ({
        id      : type,
        name    : this.getName(type),
        children: this.getChildren(type)
      }))

      return [{
        id  : 1,
        name: 'All Breweries',
        children
      }]
    },
    selections () {
      const selections = []

      for (const leaf of this.tree) {
        const brewery = this.breweries.find(brewery => brewery.id === leaf)

        if (!brewery) continue

        selections.push(brewery)
      }

      return selections
    },
    shouldShowTree () {
      return this.breweries.length > 0 && !this.isLoading
    }
  },

  watch: {
    breweries (val) {
      this.types = val.reduce((acc, cur) => {
        const type = cur.brewery_type

        if (!acc.includes(type)) acc.push(type)

        return acc
      }, []).sort()
    }
  },

  methods: {
    changeSkill () {
      let id = this.$route.params.id
      let skills = this.$store.getters.getSkills
      for (let i = 0; i < skills.length; i++) {
        if (skills[i].id == id) {
          skills[i] = {
            id                 : this.$route.params.id,
            title              : this.editSkill.title ? this.editSkill.title : this.currentSkill.title,
            type               : this.editSkill.type ? this.editSkill.type : this.currentSkill.type,
            category           : this.editSkill.category ? this.editSkill.category : this.currentSkill.category,
            url                : this.editSkill.url ? this.editSkill.url : this.currentSkill.url,
            git                : this.editSkill.git ? this.editSkill.git : this.currentSkill.git,
            connectedCategories: this.editSkill.connectedCategories ? this.editSkill.connectedCategories : this.currentSkill.connectedCategories,
            parentSkill        : this.editSkill.parentSkill ? this.editSkill.parentSkill : this.currentSkill.parentSkill,
            childSkills        : this.editSkill.childSkills ? this.editSkill.childSkills : this.currentSkill.childSkills,
            tags               : this.editSkill.tags ? this.editSkill.tags : this.currentSkill.tags,
            description        : this.editSkill.description ? this.editSkill.description : this.currentSkill.description,
            version            : this.editSkill.version ? this.editSkill.version : this.currentSkill.version,
            employees          : this.editSkill.employees ? this.editSkill.employees : this.currentSkill.employees,
            projects           : this.editSkill.projects ? this.editSkill.projects : this.currentSkill.projects
          }
          this.$store.commit('editSkill', {data: skills[i]})
          this.dialog = false
          // todo: make fields optional and save old values
          if (this.editSkill.type) alert(this.editSkill.type)
          if (this.editSkill.category) alert(this.editSkill.category)
          this.currentSkill = skills[i]
          this.editErrorMsg = ''
          return
        }
      }
      this.editErrorMsg = 'Oops! Something goes wrong'
    },
    deleteSkill () {
      let id = this.$route.params.id
      this.$store.commit('deleteSkill', {data: {id: id}})
      this.deleteErrorMsg = ''
      this.dialogDelete = false
      this.$router.push('/main/skillslist')
    },
    fetch () {
      if (this.breweries.length) return

      return fetch('https://api.openbrewerydb.org/breweries')
        .then(res => res.json())
        .then(data => (this.breweries = data))
        .catch(err => console.log(err))
    },
    getChildren (type) {
      const breweries = []

      for (const brewery of this.breweries) {
        if (brewery.brewery_type !== type) continue

        breweries.push({
          ...brewery,
          name: this.getName(brewery.name)
        })
      }

      return breweries.sort((a, b) => {
        return a.name > b.name ? 1 : -1
      })
    },
    getName (name) {
      return `${name.charAt(0).toUpperCase()}${name.slice(1)}`
    }
  }
}
</script>

<style scoped>
  h2 {
    font-family    : 'Avenir', Helvetica, Arial, sans-serif;
    padding-top    : 10px;
    padding-bottom : 20px;
    display        : inline-block;
  }
</style>
